/* im2png.c - Aurora .im to .png file converter
 * Copyright 2015 Mihai Gaitos, mihaig@hawk.ro
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <inttypes.h>
#include <malloc.h>
#include <stdlib.h>

#include "gfunctions.c"
#include "pngop.c"

#include "imdec.c"

int main(int argc, char *argv[]) 
{
if(argc<3)
	{
	fprintf(stderr,"Usage: %s <src> <dest>\n",argv[0]);
	exit(-1);
	}

void *ibuf;
int r=readim(argv[1],&ibuf);
if(r!=0)
	{
	exit(r);
	}

unsigned char *rbuf=NULL;
palentry *pal=NULL; /* palette */
unsigned int sx,sy;
procim(ibuf,&rbuf,&pal,&sx,&sy); /* this mallocs memory for rbuf and pal */
free(ibuf);
if(rbuf==NULL)
	{
	fprintf(stderr,"Picture was not decoded\n");
	return -1;
	}
	
M_Surface *scr=M_CreateSurface(sx,sy,32);
showpic(scr,rbuf,pal,sx,sy,0,0);
free(rbuf);
free(pal);
save_png_to_file(scr,argv[2]);
free(scr);
return(0);
} 

