/* imview.c - Aurora .im file viewer.
 * This is mainly to test the decoder (imdec.c) 
 * Copyright 2015 Mihai Gaitos, mihaig@hawk.ro
 *
 * Permission is hereby granted, without written agreement and without
 * license or royalty fees, to use, copy, modify, and distribute this
 * software and its documentation for any purpose, provided that the
 * above copyright notice and the following two paragraphs appear in
 * all copies of this software.
 *
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 * ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN
 * IF THE COPYRIGHT HOLDER HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 *
 * THE COPYRIGHT HOLDER SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING,
 * BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE COPYRIGHT HOLDER HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <SDL/SDL.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>

#define SDL
#include "gfunctions.c"
/* #include "pngop.c" */


#include "imdec.c"


int main(int argc, char *argv[]) 
{
if(argc<2)
	{
	fprintf(stderr,"Usage: %s <file>\n",argv[0]);
	exit(-1);
	}
void *ibuf;
int r=readim(argv[1],&ibuf);
if(r!=0)
	{
	exit(r);
	}
/* commented because there is no use for this now. Be careful with the names if you use that!
 * also see case SDLK_s: below and include "pngop.c" above and keep in mind that you will need
 * to compile with -lpng - lSDL

char *basename=strtok(argv[1],".");	// used for savepng; won't work with more than one . in the filename
char *nname=malloc(1024); 		// keep your path sane!
snprintf(nname,1024,"%s.png",basename);
*/

unsigned char *rbuf=NULL;	/* result buffer */
palentry *pal=NULL;		/* palette */
unsigned int sx,sy;
procim(ibuf,&rbuf,&pal,&sx,&sy); /* this mallocs memory for rbuf and pal */
if(rbuf==NULL)
	{
	fprintf(stderr,"Picture was not decoded\n");
	exit (3);
	}

/* here we should have everythin (.im related) ready, so prepare for graphics mode */
SDL_Event event;
SDL_Surface *scr;
SDL_Init(SDL_INIT_VIDEO);	/* initialise SDL & the video subsystem */
scr=SDL_SetVideoMode(sx,sy,0,SDL_HWSURFACE);
if(scr==NULL) /* maybe you forgot to startx? :) */
	{
	fprintf(stderr,"Could not create SDL window\n");
	exit(-64);
	}

showpic(scr,rbuf,pal,sx,sy,0,0); /* paint rbuf on scr with palette */

SDL_Flip(scr); /* display image */
while(SDL_WaitEvent(&event)>0) 
	{
	switch(event.type) 
		{
		case SDL_KEYDOWN:
			switch(event.key.keysym.sym)
				{
/*				case SDLK_s:
					save_png_to_file(scr,nname);
					printf("Image saved to %s\n",nname);
					break; */
				case SDLK_ESCAPE:
					SDL_Quit();
					break;
				}
			break;
		case SDL_QUIT: /* on window close */
			SDL_Quit();
			break;
		}
	}
free(ibuf);
free(rbuf);
free(pal);
/* free(nname); */
return 0;
} 

